' #########################################################
'
'           --==**  CALL_SUBST.VBS   **==--
'
' #########################################################
'       (c) 2000 * Axel Hahn * support@axel-hahn.de
' #########################################################
'
'     This VB-Skript is a part of the freeware tool
'     SUBST4WIN.
'     Always distribute the complete software package
'     and not as standalone script!
'
'     Dieses VB-Skript ist Teil des Freeware-Tools
'     SUBST4WIN.
'     Bei der Weitergabe des Programmes ist das gesamte
'     Software-Paket zu kopieren - nicht nur dieses
'     Skript!
'
' ---------------------------------------------------------
' history:
' V0.9 - 01.05.2000 - first free BETA-version
' V1.0 - 20.05.2000 - That's it! Welcome to the show!
' V1.0c - 26.02.2005 - changes for Windows XP (its subst 
'                      has another output format)
' ---------------------------------------------------------
' to get a small help:
' call this script without any parameter!
' for more information: run subst4w.hlp
'
' um eine kleine Hilfe zu erhalten:
' Dieses Skript einfach ohne Parameter aufrufen.
' Fr weitere Informationen rufen Sie subst4w.hlp auf.
' ---------------------------------------------------------
' returncodes:
'	0 - successful execution
'	1 - no parameters were given to the script
'	2 - function "add": wrong parametercount
'	3 - function "delete": wrong parametercount
' ---------------------------------------------------------
'
' #########################################################

' ---------------------------------------------------------
' set variables
' ---------------------------------------------------------
	language="de"
	myfolder=Mid(WScript.ScriptFullname,1,len(WScript.ScriptFullname)-len(WScript.ScriptName))
	helpfile=myfolder & "SUBST4W.HLP"

	set myDIC = CreateObject("Scripting.Dictionary")

	myDIC.Add "txt_error_de", "!!! FEHLER !!!" + vbcrlf
	myDIC.Add "txt_askbeforeExecute_de", "Frage: Folgendes ausfhren ?" + vbcrlf + vbcrlf

	myDIC.Add "fkt_add_de", "Funktion: /add <<subst-Laufwerk erstellen>>" + vbcrlf
	myDIC.Add "fkt_check_de", "Funktion: /check <<installierte Features testen>>" + vbcrlf
	myDIC.Add "fkt_delete_de", "Funktion: /delete <<subst-Laufwerk entfernen>>" + vbcrlf
	myDIC.Add "fkt_install_0_de", "Funktion: /install:0 <<Autostart einrichten>>" + vbcrlf
	myDIC.Add "fkt_install_1_de", "Funktion: /install:1 <<Kontextmen [Arbeitsplatz] erweitern>>" + vbcrlf
	myDIC.Add "fkt_install_2_de", "Funktion: /install:2 <<Kontextmen [Dateiordner] erweitern>>" + vbcrlf
	myDIC.Add "fkt_makelist_de", "Funktion: /makelist <<subst-Laufwerke ermitteln>>" + vbcrlf
	myDIC.Add "fkt_restore_de", "Funktion: /restore <<subst-Laufwerk wiederherstellen>>" + vbcrlf
	myDIC.Add "fkt_uninstall_0_de", "Funktion: /uninstall:0 <<Autostart entfernen>>" + vbcrlf
	myDIC.Add "fkt_uninstall_1_de", "Funktion: /uninstall:1 <<Arbeitsplatz-erweiterung entfernen>>" + vbcrlf
	myDIC.Add "fkt_uninstall_2_de", "Funktion: /uninstall:2 <<Kontextmen-Eintrag unter [Dateiordner] entfernen>>" + vbcrlf

	myDIC.Add "error_usage_de", _
		"Dieses Skript kann nur mit Parametern aufgerufen werden." + vbcrlf + _
		vbcrlf + _
		WScript.Scriptname + " /[Funktion] [Param2 [Param3]]"+ vbcrlf + _
		vbcrlf + _
		"Funktion:"+ vbcrlf + _
		"     /add [LW-buchstabe:] [Pfad]  -  subst-Laufwerk erstellen"+ vbcrlf + _
		"     /check -  installierbare Features testen (s. /install)"+ vbcrlf + _
		"     /delete [LW-buchstabe:]  -  subst-Laufwerk lschen"+ vbcrlf + _
		"     /install:[Nr] -  Installieren (s. Nr.)"+ vbcrlf + _
		"     /makelist [Datei]  -  Auflisten aller virtuellen Laufwerke"+ vbcrlf + _
		"     /restore [Datei]  -  subst-Laufwerke wiederherstellen"+ vbcrlf + _
		"     /uninstall:[Nr] -  De-Installieren (s. Nr.)"+ vbcrlf + _
		vbcrlf + _
		"Nr: (nur /install und /uninstall)"+ vbcrlf + _
		"     0  -  Startmen-Eintrag"+ vbcrlf + _
		"     1  -  Eintrag im Kontextmen des Arbeitsplatz"+ vbcrlf + _
		"     2  -  Eintrag im Kontextmen von Ordnern"+ vbcrlf + _
		""

	myDIC.Add "error_AddWrongParamCount_de", _
		"Fehlermeldung: falsche Parameteranzahl!" + vbcrlf + _
		"Beim Hinzufgen eines SUBST-Laufwerkes geben Sie an:" + vbcrlf + _
		"* das SUBST-Laufwerk an, das erzeugt werden soll"+ vbcrlf + _
		"* den Zielordner, wohin das Laufwerk zeigen soll"+ vbcrlf + _
		""
	myDIC.Add "error_nothingToDelete_de", _
		"Fehlermeldung: falsche Parameteranzahl!" + vbcrlf + _
		"Geben Sie das SUBST-Laufwerk an, das gelscht werden soll."+ vbcrlf + _
		""

	myDIC.Add "lnk_name_de", "alle SUBST-Laufwerke wiederherstellen.LNK"

	myDIC.Add "error_CannotCreateLink_01_de", _
		"Fehlermeldung: Das Link-Objekt konnte nicht erstellt werden!" + vbcrlf + _
		""
	myDIC.Add "error_CannotCreateLink_02_de", _
		"Fehlermeldung: folgender Link konnte nicht erstellt werden:" + vbcrlf + _
		""

	myDIC.Add "error_FileNotFound_de", _
		"Fehlermeldung: folgende Datei wurde nicht gefunden:" + vbcrlf + _
		""

	myDIC.Add "error_ObjRun_de", "Hinweis (Fehlermeldung??):" + vbcrlf + _
		"Die Ausfhrung folgender Anweisung liefert einen Returncode ungleich Null:" + vbcrlf + _
	""
	myDIC.Add "error_NotImplemented_de", _
		"Fehlermeldung:" + vbcrlf + _
		"Diese Funktion ist im VB-Skript noch nicht implementiert!" + vbcrlf + _
		""

	' install:2
	myDIC.Add "regkey_mycomputer",_
	    "HKCR\Clsid\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\shell\"
	myDIC.Add "reg_mycomputer_menuname_de", "Subst4Win - &virtuelle Laufwerke verwalten\"
	myDIC.Add "reg_mycomputer_menucommand_de", myfolder & "subst4w.exe"

	' install:3
	myDIC.Add "regkey_folders", "HKEY_CLASSES_ROOT\Directory\shell\"
	myDIC.Add "reg_folders_menuname_de", "als neues &virtuelles Laufwerk anlegen...\"
	myDIC.Add "reg_folders_menucommand_de", myfolder & "subst4w.exe ""%1"""

	myDIC.Add "error_CannotCreateRegKey_de",_
		"Fehlermeldung: folgender Registry-Schlssel konnte nicht erstellt werden:" + vbcrlf + _
		""
	myDIC.Add "error_CannotCreateRegValue_de",_
		"Fehlermeldung: folgender Registry-Wert konnte nicht erstellt werden:" + vbcrlf + _
		""

	' uninstall:0
	myDIC.Add "txt_FrageDateiLoeschen_de", "Folgende Datei wird nun gelscht:" + vbcrlf

	' uninstall:1+2
	myDIC.Add "error_CannotDeleteRegValue_de",_
		"Fehlermeldung: folgender Registry-Schlssel konnte nicht gelscht werden:" + vbcrlf + _
		""
	' uninstall:1+2
	myDIC.Add "error_FeatureNotDetected_de",_
		"Fehlermeldung: Das zu deinstallierende Feature ist gar nicht eingerichtet gewesen." + vbcrlf + _
		""

	' check
	myDIC.Add "txt_autostart_de","Wiederherstellen der virtuellen LW bei Windowsstart? " & vbCrLf
	myDIC.Add "txt_myComputerMenu_de","Arbeitsplatz - Kontextmen erweitert? " & vbCrLf
	myDIC.Add "txt_foldersMenu_de","Dateiordner - Kontextmen erweitert? " & vbCrLf

	myDIC.Add "txt_Found_de", "     JA - ist installiert" & vbCrLf & vbCrLf
	myDIC.Add "txt_NotFound_de", "     nein - nicht eingerichtet" & vbCrLf & vbCrLf

	Set fso = CreateObject("Scripting.FileSystemObject")
	set Shell=CreateObject("WScript.Shell")
	sDataDir = Shell.SpecialFolders("appdata")&"\subst4win\"
	myfile=sDataDir&"subst4w_drives.txt"
	
' ---------------------------------------------------------
' ask for given params
' ---------------------------------------------------------
	set args = WScript.Arguments
	' msgBox(args.Count)
	if (args.Count=0) then
		ShowError(myDIC.Item("error_usage_" + language))
		WScript.Quit 1
	end if

' ---------------------------------------------------------
' execute the functions given by parameter
' ---------------------------------------------------------
select case args(0)
	case "/add"
		' -----------------------------------------
		' add a virtual drive
		' -----------------------------------------
		fkt=myDIC.Item("fkt_add_" + language)
		if args.Count>=3 then
			cmd="%COMSPEC% /c subst " & args(1) & " """ & args(2) & """"
			call RUN(cmd)
		else
			myErr=myDIC.Item("error_AddWrongParamCount_" + language)
			ShowError(fkt & myErr)
			WScript.Quit 2
		end if

	case "/check"
		' -----------------------------------------
		' check the installed features
		' -----------------------------------------
		fkt=myDIC.Item("fkt_check_" + language)
		check_features

	case "/delete"
		' -----------------------------------------
		' delete a virtual drive
		' -----------------------------------------
		fkt=myDIC.Item("fkt_delete_" + language)
		if args.Count>=2 then
			cmd="%COMSPEC% /c subst /d " & args(1)
			call RUN(cmd)
		else
			myErr=myDIC.Item("error_nothingToDelete_" + language)
			ShowError(fkt & myErr)
			WScript.Quit 3
		end if

	case "/install"
		' -----------------------------------------
		' install all features after asking the user
		' -----------------------------------------
		if (MsgBox(myDIC.Item("txt_askbeforeExecute_" + language) & myDIC.Item("fkt_install_0_" + language), vbYesNo, WScript.ScriptName,helpfile,6000) = vbyes) then
			install_0
		end if
		if (MsgBox(myDIC.Item("txt_askbeforeExecute_" + language) & myDIC.Item("fkt_install_1_" + language), vbYesNo, WScript.ScriptName,helpfile,6000) = vbyes) then
			install_1
		end if
		if (MsgBox(myDIC.Item("txt_askbeforeExecute_" + language) & myDIC.Item("fkt_install_2_" + language), vbYesNo, WScript.ScriptName,helpfile,6000) = vbyes) then
			install_2
		end if

	case "/install:0"
		' -----------------------------------------
		' install autostart
		' -----------------------------------------
		install_0

	case "/install:1"
		' -----------------------------------------
		' install extension unter my computer
		' -----------------------------------------
		install_1

	case "/install:2"
		' -----------------------------------------
		' install extension of context menu "folder"
		' -----------------------------------------
		install_2

	case "/makelist"
		' -----------------------------------------
		' get a list of the existing virtual drives
		' -----------------------------------------
		fkt=myDIC.Item("fkt_makelist_" + language)
		if args.Count>=2 then myfile=args(1)
		cmd="%COMSPEC% /c subst.exe >" & """" & myfile & """"
		call RUN(cmd)

	case "/restore"
		' -----------------------------------------
		' restore virtual drives
		' -----------------------------------------
		fkt=myDIC.Item("fkt_restore_" + language)
		ForReading=1
		if args.Count>=2 then myfile=args(1)
		Set fso = CreateObject("Scripting.FileSystemObject")
		if fso.FileExists(myfile) then
			Set f = fso.OpenTextFile(myfile, ForReading, False)
			if fso.GetFile(myfile).size>0 then
				Do
					Line=F.ReadLine
					Drive=Mid(Line,1,2)
					' Target=Mid(Line,7)
					Target=Split(Line, "=> ")(1)
					' MsgBox ("drive=" & Drive & " | target=" & Target)
					cmd="%COMSPEC% /c subst " & Drive & " """ & Target & """"
					call RUN(cmd)
				Loop until f.AtEndOfStream
			end if
			f.Close
		else
			myErr=myDIC.Item("error_FileNotFound_" + language) & myfile
			ShowError(fkt & myErr)
		end if

		cmd="subst"

	case "/uninstall:0"
		' -----------------------------------------
		' uninstall autostart
		' -----------------------------------------
		uninstall_0

	case "/uninstall:1"
		' -----------------------------------------
		' uninstall extension unter my computer
		' -----------------------------------------
		uninstall_1

	case "/uninstall:2"
		' -----------------------------------------
		' uninstall extension of context menu "folder"
		' -----------------------------------------
		uninstall_2

	case else
		' -----------------------------------------
		' if parameter was wrong...
		' -----------------------------------------
		ShowError(myDIC.Item("error_usage_" + language))
		WScript.Quit 1

end select

WScript.Quit 0

' #########################################################
'
' 	SUBS
'
' #########################################################

function check_features

	mymsg=fkt & vbCrLf

	' ----------------------------------------------
	' check 0 - autostart
	' ----------------------------------------------
	mymsg= mymsg & myDIC.Item("txt_autostart_" + language)
	target=myDIC.Item("lnk_name_" + language)
	' set Shell=WScript.CreateObject("WScript.Shell")
	mystartmenu=Shell.SpecialFolders("Startup")
	Set fso = CreateObject("Scripting.FileSystemObject")

	if fso.FileExists(mystartmenu & "\" & target) then
		mymsg= mymsg & myDIC.Item("txt_Found_" + language)
	else
		mymsg= mymsg & myDIC.Item("txt_NotFound_" + language)
	end if

	' ----------------------------------------------
	' check 1 - myComputer
	' ----------------------------------------------
	mymsg= mymsg & myDIC.Item("txt_myComputerMenu_" + language)
	Regvalue=myDIC.Item("regkey_mycomputer") & myDIC.Item("reg_mycomputer_menuname_" + language)
	if test_RegKey(Regvalue)=true then
		mymsg= mymsg & myDIC.Item("txt_Found_" + language)
	else
		mymsg= mymsg & myDIC.Item("txt_NotFound_" + language)
	end if


	' ----------------------------------------------
	' check 2 - folder-extension
	' ----------------------------------------------
	mymsg= mymsg & myDIC.Item("txt_foldersMenu_" + language)
	Regvalue=myDIC.Item("regkey_folders") & myDIC.Item("reg_folders_menuname_" + language)
	if test_RegKey(Regvalue)=True then
		mymsg= mymsg & myDIC.Item("txt_Found_" + language)
	else
		mymsg= mymsg & myDIC.Item("txt_NotFound_" + language)
	end if

	' ----------------------------------------------
	' output
	' ----------------------------------------------
	MsgBox mymsg

end function


function install_0
	fkt=myDIC.Item("fkt_install_0_" + language)
	target=myDIC.Item("lnk_name_" + language)

	' set Shell=WScript.CreateObject("WScript.Shell")
	mystartmenu=Shell.SpecialFolders("Startup")

	On Error Resume Next
	set Link=Shell.CreateShortCut(mystartmenu & "\" & target)
	if Err.Number=0 then

		Link.TargetPath=WScript.ScriptFullname
		Link.Arguments="/restore"
		Link.Description="restore saved SUBST drives"
		Link.WorkingDirectory=myfolder
		Link.Save
		if Err.Number>0 then
			myErr=myDIC.Item("error_CannotCreateLink_02_" + language) & mystartmenu & "\" & target
			ShowError(fkt & myErr)
			WScript.Quit 222
		end if
	else
		myErr=myDIC.Item("error_CannotCreateLink_01_" + language)
		ShowError(fkt & myErr)
		WScript.Quit 111
	end if

end function


function install_1
	fkt=myDIC.Item("fkt_install_1_" + language)
	myErr=myDIC.Item("error_NotImplemented_" + language)
	Create_Contextmenu _
		myDIC.Item("regkey_mycomputer"), _
		myDIC.Item("reg_mycomputer_menuname_" + language),_
		myDIC.Item("reg_mycomputer_menucommand_" + language)
end function


function install_2
	fkt=myDIC.Item("fkt_install_2_" + language)
	Create_Contextmenu _
		myDIC.Item("regkey_folders"), _
		myDIC.Item("reg_folders_menuname_" + language),_
		myDIC.Item("reg_folders_menucommand_" + language)
end function


function uninstall_0
	fkt=myDIC.Item("fkt_uninstall_0_" + language)
	target=myDIC.Item("lnk_name_" + language)

	' set Shell=WScript.CreateObject("WScript.Shell")
	mystartmenu=Shell.SpecialFolders("Startup")

	myfile=mystartmenu & "\" & target
  	Set fso = CreateObject("Scripting.FileSystemObject")

	if fso.FileExists(myfile) then
		' if MsgBox(fkt & myDIC.Item("txt_FrageDateiLoeschen_" + language) & myfile, vbyesno)=vbyes then
  			fso.DeleteFile(myfile)
		' end if
	else
		myErr=myDIC.Item("error_FeatureNotDetected_" + language)
		ShowError(fkt & myErr)
	end if
end function

function uninstall_1
	fkt=myDIC.Item("fkt_uninstall_1_" + language)
	Regvalue=myDIC.Item("regkey_mycomputer") & myDIC.Item("reg_mycomputer_menuname_" + language)
	if (test_RegKey(Regvalue)=True) then
		delete_RegKey Regvalue
	else
		myErr=myDIC.Item("error_FeatureNotDetected_" + language)
		ShowError(fkt & myErr)
	end if
end function

function uninstall_2
	fkt=myDIC.Item("fkt_uninstall_2_" + language)
	Regvalue=myDIC.Item("regkey_folders") &  myDIC.Item("reg_folders_menuname_" + language)
	if (test_RegKey(Regvalue)=true) then
		delete_RegKey Regvalue
	else
		myErr=myDIC.Item("error_FeatureNotDetected_" + language)
		ShowError(fkt & myErr)
	end if
end function


' #########################################################


' ---------------------------------------------------------
' execute a program
' 	IN : 1 = command-string
' 	OUT: returncode of execution
' ---------------------------------------------------------
function RUN(cmdstr)
	' set OBJ_shell = WScript.CreateObject("WScript.Shell")
	' result = OBJ_shell.Run(cmdstr,0,true)
	result = Shell.Run(cmdstr,0,true)
	if result>0 then
		ShowError(myDIC.Item("error_ObjRun_" + language) &vbcrlf& "command: " & cmdstr &vbcrlf& "returncode: " & result )
		WScript.Quit result
	end if
	RUN=result
end function


' ---------------------------------------------------------
' show an errormessage
' 	IN : 1 = message
' 	OUT: result of MsgBox
' ---------------------------------------------------------
function ShowError(message)
	mymsg=myDIC.Item("txt_error_" + language) & message
	result=MsgBox (mymsg, vbOKonly+vbcritical,WScript.Scriptname,helpfile,6000)
end function


' ---------------------------------------------------------
' create entry in contextmenu
' 	IN : 1 = name of the registry key
'	     2 = name of the visible menu text
'	     3 = command to execute
' 	OUT: nothing
' ---------------------------------------------------------
function Create_Contextmenu(rkey, menuitem, execmd)
	if (create_RegKey(rkey & menuitem)=0) then
		if (create_RegKey(rkey & menuitem & "command\")=0) then
			Create_Contextmenu=create_RegValue(rkey & menuitem & "command\", execmd)
		end if
	end if
end function


' ---------------------------------------------------------
' create registry key
' 	IN : 1 = name of the registry key
' 	OUT: Err.Number
' ---------------------------------------------------------
function create_RegKey(regkey)
	' set Shell=WScript.CreateObject("WScript.Shell")
	On Error Resume Next
	Shell.RegWrite regkey,""
	if Err.Number>0 then
		myErr=myDIC.Item("error_CannotCreateRegKey_" + language & regkey)
		showerror(fkt & myErr)
	end if
	create_RegKey=Err.Number
end function


' ---------------------------------------------------------
' create registry value
' 	IN : 1 = name of the registry key + name
'	     2 = value
' 	OUT: Err.Number
' ---------------------------------------------------------
function create_RegValue(regentry, regvalue)
	' set Shell=WScript.CreateObject("WScript.Shell")
	On Error Resume Next
	Shell.RegWrite regentry,regvalue
	if Err.Number>0 then
		myErr=myDIC.Item("error_CannotCreateRegValue_" + language & regentry & " = " &regvalue)
		showerror(fkt & myErr)
	end if
	create_RegKey=Err.Number
end function

' ---------------------------------------------------------
' check: does the registry key/ value exists??
' 	IN : 1 = name of the registry entry
' 	OUT: true or false
' ---------------------------------------------------------
function test_RegKey(regkey)
	' dim Shell, result, wert
	dim result, wert
	result=true
	On Error Resume Next
	' set Shell=WScript.CreateObject("WScript.Shell")
	wert=Shell.RegRead(regkey)

	if (Err.Number>0) or (wert=vbempty) then
		result=false
	end if
	test_RegKey=result
end function

' ---------------------------------------------------------
' delete registry key or value
' 	IN : 1 = name of the registry key or value
' 	OUT: Err.Number
' ---------------------------------------------------------
function delete_RegKey(regentry)
	' dim Shell
	' On Error Resume Next
	' set Shell=WScript.CreateObject("WScript.Shell")
	Shell.RegDelete regentry
	if Err.Number>0 then
		myErr=myDIC.Item("error_CannotDeleteRegValue_" + language & regentry)
		showerror(fkt & myErr)
	end if
	delete_RegKey=Err.Number
end function

' #########################################################